#include "parameters.h"

__global__ void cuda_kernel(int *B,int *A){
	int total_task = blockDim.x * gridDim.x;
	int task_sn = blockIdx.x*blockDim.x + threadIdx.x;
	
	// Locate the first element in data partition
	int length = SIZE/total_task;
	int   head = task_sn * length;
	
	// For each element in the partition
	for(int i=head ; i<head+length ; i++ ){
		int tmp = A[i];
		B[i] = tmp;
		
		for(int j=1;j<LOOP;j++)
			B[i] *= tmp;
	}

	return;
};

float GPU_kernel(int *B,int *A){

	int *dA,*dB;

	// Creat Timing Event
  	cudaEvent_t start, stop;
	cudaEventCreate (&start);
	cudaEventCreate (&stop); 	

	// Allocate Memory Space on Device
	
	// Copy Data to be Calculated
	
	// Start Timer
	cudaEventRecord(start, 0);

	// Lunch Kernel
	cuda_kernel<<<1,1>>>(dB,dA);

	// Stop Timer
	cudaEventRecord(stop, 0);
  	cudaEventSynchronize(stop); 

	// Copy Output back
	
	// Release Memory Space on Device
	
	// Calculate Elapsed Time
  	float elapsedTime; 
  	cudaEventElapsedTime(&elapsedTime, start, stop);  

	return elapsedTime;
}